*
*Programa de acesso ao servio de rastreamento de objetos dos correios (sro);
*Autor: Fabiano Ferreira;
*Em 23/07/2019;
*Baseado na ideia de Patrick Barbosa,
*Que desenvolveu antes um script de interface com a pgina dos correios;
*

*Variveis:
*Dataobjeto: data registrada para o estado do objeto;
*Horaobjeto: hora registrada para o estado do objeto;
*Lugarobjeto: onde o objeto est na data e hora registrada;
*Statusobjeto: estado do objeto (o que aconteceu com o objeto);
*
*rotinas:
*ObtemCodigoObjeto: aceita a entrada de um cdigo de rastreio;
*pesquisacodigoobjeto: pesquisa na base dos correios pelo objeto vinculado ao cdigo de rastreio;
*processainformacoesobjeto: extrai somente as informaes necessrias para trabalhar depois;
*Escolheropcao: Apresenta um menu com as seguintes opes:
*Ver ltima atualizao;
*Ver detalhes do objeto;
*Monitorar estado do objeto;
*Nova consulta;
*Sair;
*

escreve "Taonde - rastreamento de objetos nos correios"

@inicio
chama @obtemcodigoobjeto
chama @pesquisacodigoobjeto
chama @processainformacoesobjeto
Escreve "Escolha sua opo"
escreve ""
chama @escolheropcao
desvia @inicio
*

@obtemcodigoobjeto
escreve "Entre com o cdigo do objeto a pesquisar:"
le $codigo
se $codigo = "" termina mudo
escreve "Aguarde"
retorna

@pesquisacodigoobjeto
seja $pesquisa ""
seja $arqtemp "..\temp\sro.html"
seja $baseurl "httpS://www.websro.com.br/detalhes.php?P_COD_UNI="
concatena $pesquisa $baseurl
concatena $pesquisa $codigo

remove $arqtemp &
trazdarede $pesquisa $arqtemp 0 "" "webvox" x
retorna

@processainformacoesobjeto
seja $arqinfo "..\temp\sro.info"
seja m ""

remove $arqinfo &
abre #1 $arqtemp
le #1 l
checa c
enquanto c = 0
concatena m l
le #1 l
checa c
fim enquanto
fecha #1

abre #1 $arqinfo &

seja p pos "'top'>" m
se p = 0 desvia @erro
enquanto p > 0
soma p 6
seja t tamanho m
copia m m p t
seja p pos "<" m
subtrai p 1
copia $dataobjeto m 1 p
seja $dataobjeto trim $dataobjeto
escreve #1 $dataobjeto

soma p 5
seja t tamanho m
copia m m p t
seja p pos "<" m
subtrai p 1
copia $horaobjeto m 1 p
seja $horaobjeto trim $horaobjeto
escreve #1 $horaobjeto

seja p pos "<label>" m
soma p 7
seja t tamanho m
copia m m p t
seja p pos "<" m
subtrai p 1
copia $lugarobjeto m 1 p
utf8paraansi $lugarobjeto
seja $lugarobjeto trim $lugarobjeto
escreve #1 $lugarobjeto

seja p pos "<strong>" m
soma p 8
seja t tamanho m
copia m m p t
seja p pos "<" m
subtrai p 1
copia $statusobjeto m 1 p
seja $statusobjeto trim $statusobjeto

seja p pos "<br>" m
soma p 4
seja t tamanho m
copia m m p t
seja m trim m
seja p pos "</td>" m
subtrai p 1
copia $deparaobjeto m 1 p
seja $enter crlf
substitui $deparaobjeto "<br>" $enter
seja $deparaobjeto trim $deparaobjeto
concatena $statusobjeto " - "
concatena $statusobjeto $deparaobjeto

utf8paraansi $statusobjeto
escreve #1 $statusobjeto
escreve #1 ""

seja p pos "'top'>" m
fim enquanto
fecha #1
retorna
*

@escolheropcao
seja $numeroitem 1
seja $primeiroitem "Ver ltima atualizao"
seja $segundoitem "Ver detalhes"
seja $terceiroitem "Monitorar"
seja $quartoitem "Nova consulta"
seja $quintoitem "sair"

menu cria 1 1 30 5
menu adiciona $primeiroitem
menu adiciona $segundoitem
menu adiciona $terceiroitem
menu adiciona $quartoitem
menu adiciona $quintoitem
@fixomenuitem
menu executa $numeroitem $letraitem $textoitem
se $letraitem = "#13"
se $numeroitem = 1 chama @verultimaatualizacao
se $numeroitem = 2 chama @verdetalhes
se $numeroitem = 3 chama @monitorar
se $numeroitem = 4 menu termina
se $numeroitem = 4 retorna
se $numeroitem = 5 chama @sair
se $numeroitem < 4 desvia @escolheropcao
fim se
se $letraitem = "#27" chama @sair
desvia @fixomenuitem
*

@verultimaatualizacao
menu termina
seja $numnull 1
Escreve "ltima atualizao:"
escreve ""

menu cria 1 1 80 10

abre #1 $arqinfo
le #1 l
enquanto l <> ""
menu adiciona l
le #1 l
fim enquanto
fecha #1

Escreve "Leia com as setas"
@fixomenunull
menu executa $numnull $tecnull $texnull
se $tecnull = "#27"
menu termina
escreve "Escolha sua opo"
retorna
fim se
desvia @fixomenunull
*

@verdetalhes
menu termina
seja $numnull 1
Escreve "Detalhes do objeto:"
escreve ""

menu cria 1 1 80 30

abre #1 $arqinfo
le #1 l
checa c
enquanto c = 0
se l <> ""menu adiciona l
le #1 l
checa c
fim enquanto
fecha #1

Escreve "Leia com as setas"
@fixomenunull
menu executa $numnull $tecnull $texnull
se $tecnull = "#27"
menu termina
escreve "Escolha sua opo"
retorna
fim se
desvia @fixomenunull
*

@monitorar
Escreve "Iniciando monitor de objetos para "$codigo
seja $iniciamonitor "taonde_mon "
concatena $iniciamonitor $codigo
concatena $iniciamonitor " 10"
executa $iniciamonitor &
espera 2
@monitorando
bipa 1
le mudo t &
se t = "#13"
busca b $arqinfo
se b = "" desvia @monitorando
abre #1 $arqinfo
le #1 $dataobjeto
le #1 $horaobjeto
le #1 $lugarobjeto
le #1 $statusobjeto
fecha #1
bipa 1
escreve $dataobjeto
bipa 1
escreve $horaobjeto
bipa 1
escreve $lugarobjeto
bipa 1
escreve $statusobjeto
seno
se t = "#27"
 chama @paramonitor
retorna
fim se
desvia @monitorando
*

@paramonitor
remove "stop"&
abre #1 "stop"&
fecha #1
escreve "Parando monitor"
chama @pesquisacodigoobjeto
chama @processainformacoesobjeto
retorna
*

@sair
escreve "Deseja sair?"
le mudo o &
se o = "s"
escreve "At logo."
termina mudo
seno
se o = "n"
retorna
seno
desvia @sair
fim  se
*

@erro
escreve "Erro!"
escreve "No foi possvel obter as informaes do objeto a partir do cdigo fornecido."
escreve "Programa enserrado"
termina mudo
