*Programa para monitorar a mudana de estado de objetos no servio dos correios;
*Por Fabiano Ferreira;
*Em 23/07/2019;
*
*Forma de usar:
*taonde_mon codigorastreio, tempomonitor;
*Codigorastreio:  o cdigo de rastreamento fornecido pelos correios de um objeto postado;
*O cdigo de rastreamento contm 13 caracteres, sendo duas letras iniciais, 9 algarismos e termina com BR;
*Temporastreio  o tempo, em segundos, que o programa ir verificar se houve mudana do estado de objeto;
*
*Para fechar, pode matar o processo pelo gerenciador de tarefas ou pelo comando taskkill,
*ou pode tambm criar um arquivo vazio chamado stop,
*no diretrio corrente;
*

chama @inicia
seja $primeiravez 1
chama @monitora
chama @finaliza
*

@inicia
seja $arqinfo "..\temp\sro.info"
seja $entrada params
se $entrada = 0 termina mudo
tela minimizada
seja $codigo palavra 2 $entrada
seja $tempoemsegundos palavra 3 $entrada
remove $arqinfo &
remove "stop" &
repete r 5
toca "..\sons\waterdrop.wav"
fim repete
retorna

@monitora
seja $mudou_estado_objeto 0

se $primeiravez = 0 espera $tempoemsegundos
chama @pesquisacodigoobjeto
chama @processainformacoesobjeto
se $parar = 1 retorna
se $primeiravez = 1
 toca "..\sons\blimblimblom.wav"
 escreve "ltima atualizao para o objeto: "$codigo
 escreve ""
 escreve $dataobjeto
 escreve $horaobjeto
 escreve $lugarobjeto
 escreve $statusobjeto
seno
se $mudou_estado_objeto = 1 toca "..\sons\blimblimblom.wav"
se $mudou_estado_objeto = 1 escreve "ltima atualizao para o objeto: "$codigo
se $mudou_estado_objeto = 1 escreve ""
se $mudou_estado_objeto = 1 escreve $dataobjeto
se $mudou_estado_objeto = 1 escreve $horaobjeto
se $mudou_estado_objeto = 1 escreve $lugarobjeto
se $mudou_estado_objeto = 1 escreve $statusobjeto
fim se
seja $primeiravez 0
desvia @monitora
*********

@pesquisacodigoobjeto
seja $pesquisa ""
seja $arqtemp "..\temp\sro.html"
seja $baseurl "httpS://www.websro.com.br/rastreamento-correios.php?P_COD_UNI="
concatena $pesquisa $baseurl
concatena $pesquisa $codigo
remove $arqtemp &

trazdarede $pesquisa $arqtemp 0 "" "webvox" x
retorna
*

@processainformacoesobjeto
busca b "stop"
se b <> ""
seja $parar 1
 retorna
fim se

seja m ""

abre #1 $arqtemp
le #1 l
checa c
enquanto c = 0
concatena m l
le #1 l
checa c
fim enquanto
fecha #1

seja p pos "'top'>" m
se p = 0 desvia @erro
enquanto p > 0
soma p 6
seja t tamanho m
copia m m p t
seja p pos "<" m
subtrai p 1
copia $dataobjeto m 1 p
seja $dataobjeto trim $dataobjeto

soma p 5
seja t tamanho m
copia m m p t
seja p pos "<" m
subtrai p 1
copia $horaobjeto m 1 p
seja $horaobjeto trim $horaobjeto

seja p pos "<label>" m
soma p 7
seja t tamanho m
copia m m p t
seja p pos "<" m
subtrai p 1
copia $lugarobjeto m 1 p
utf8paraansi $lugarobjeto
seja $lugarobjeto trim $lugarobjeto

seja p pos "<strong>" m
soma p 8
seja t tamanho m
copia m m p t
seja p pos "<" m
subtrai p 1
copia $statusobjeto m 1 p
seja $statusobjeto trim $statusobjeto

seja p pos "<br>" m
soma p 4
seja t tamanho m
copia m m p t
seja m trim m
seja p pos "</td>" m
subtrai p 1
copia $deparaobjeto m 1 p
seja $enter crlf
substitui $deparaobjeto "<br>" $enter
seja $deparaobjeto trim $deparaobjeto
concatena $statusobjeto " - "
concatena $statusobjeto $deparaobjeto

utf8paraansi $statusobjeto

seja p pos "'top'>" m
fim enquanto

busca b $arqinfo
se b = ""
abre #1 $arqinfo &
escreve #1 $dataobjeto
escreve #1 $horaobjeto
escreve #1 $lugarobjeto
escreve #1 $statusobjeto
fecha #1
seno
abre #1 $arqinfo
le #1 $dataobjetoantigo
le #1 $horaobjetoantigo
le #1 $lugarobjetoantigo
le #1 $statusobjetoantigo
fecha #1

se $dataobjeto <> $dataobjetoantigo seja $mudou_estado_objeto 1
se $horaobjeto <> $horaobjetoantigo seja $mudou_estado_objeto 1
se $lugarobjeto <> $lugarobjetoantigo seja $mudou_estado_objeto 1
se $statusobjeto <> $statusobjetoantigo seja $mudou_estado_objeto 1
remove $arqinfo
abre #1 $arqinfo &
escreve #1 $dataobjeto
escreve #1 $horaobjeto
escreve #1 $lugarobjeto
escreve #1 $statusobjeto
fecha #1
fim se
retorna
*

@erro
escreve "Erro!"
escreve "No foi possvel obter as informaes do objeto a partir do cdigo fornecido."
escreve "Programa enserrado"
termina mudo

@finaliza
remove "stop"
termina mudo
